%define docdir %{_datadir}/doc/QuantLib-%{version}

Name:		QuantLib
Version:	0.3.11
Release:	3%{?dist}
Summary:	A software framework for quantitative finance
License:	BSD
Group:		System Environment/Libraries
URL:		http://www.quantlib.org
Source0:	http://download.sourceforge.net/quantlib/QuantLib-%{version}.tar.gz
Patch0:		QuantLib-0.3.11-installdatahookfix.patch
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildRequires:	boost-devel, tetex, tetex-latex, tetex-dvips, emacs

%description
QuantLib is a free/open-source library for modeling, trading, and 
risk management in real-life.

%package devel
Summary:	QuantLib development files
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}

%description devel
Static libraries and headers for QuantLib.

%package test
Summary:	The test-suite to check the setup of QuantLib
Group:		Development/Tools
Requires:	%{name} = %{version}-%{release}

%description test
The QuantLib-test-suite will validate the compiled code against pre-constructed test
cases, and helps in validating the library.

%package doc
Summary:	The documentations for QuantLib.
Group:		Documentation
Requires:	%{name} = %{version}
BuildRequires:	doxygen >= 1.3, graphviz

%description doc
This package contains documentation files generated from the source code of
QuantLib.

%prep
%setup -q
%patch0 -p1

%build
%configure CFLAGS="$RPM_OPT_FLAGS -fpermissive" CPPFLAGS="$RPM_OPT_FLAGS -fpermissive"
make %{?_smp_mflags}
cd Docs
make docs-all

%install
rm -rf $RPM_BUILD_ROOT
make DESTDIR=$RPM_BUILD_ROOT install
mkdir -p $RPM_BUILD_ROOT/%{docdir}
cp -p Docs/latex/refman.pdf $RPM_BUILD_ROOT/%{docdir}/QuantLib-%{version}-docs-refman.pdf
cp -p Docs/latex/refman.ps $RPM_BUILD_ROOT/%{docdir}/QuantLib-%{version}-docs-refman.ps
mkdir -p $RPM_BUILD_ROOT/%{_mandir}/man1/
cp -p man/*.1 $RPM_BUILD_ROOT/%{_mandir}/man1/
cp -pr Docs/man/man3 $RPM_BUILD_ROOT/%{_mandir}/
rm -rf $RPM_BUILD_ROOT/%{_libdir}/*.la
# generic names already used by other packages
mv $RPM_BUILD_ROOT/%{_mandir}/man3/history.3 $RPM_BUILD_ROOT/%{_mandir}/man3/ql-history.3
mv $RPM_BUILD_ROOT/%{_mandir}/man3/gamma.3 $RPM_BUILD_ROOT/%{_mandir}/man3/ql-gamma.3

%clean
rm -rf $RPM_BUILD_ROOT

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%files
%defattr(-,root,root)
%{_libdir}/*.so*

%files devel
%defattr(-,root,root)
%{_includedir}/ql/
%{_libdir}/libQuantLib*.a
%{_bindir}/quantlib-config
%{_mandir}/man1/quantlib-config.*
%{_datadir}/aclocal/quantlib.m4
%{_datadir}/emacs/site-lisp/*

%files test
%defattr(-,root,root)
%{_bindir}/quantlib-test-suite
%{_mandir}/man1/quantlib-test-suite.*

%files doc
%defattr(-,root,root)
%doc Authors.txt LICENSE.TXT ChangeLog.txt Readme.txt News.txt Contributors.txt
%{_mandir}/man3/*
%{_mandir}/man1/AmericanOption.*
%{_mandir}/man1/BermudanSwaption.*
%{_mandir}/man1/DiscreteHedging.*
%{_mandir}/man1/EuropeanOption.*
%{_mandir}/man1/SwapValuation.*
%{docdir}/QuantLib-%{version}-docs-refman.pdf
%{docdir}/QuantLib-%{version}-docs-refman.ps

%changelog
* Fri Nov 18 2005 Tom "spot" Callaway <tcallawa@redhat.com> 0.3.11-3
- use -fpermissive to deal with icky c++ code

* Thu Nov 17 2005 Tom "spot" Callaway <tcallawa@redhat.com> 0.3.11-2
- fix patch

* Wed Nov 16 2005 Tom "spot" Callaway <tcallawa@redhat.com> 0.3.11-1
- bump for new release

* Fri Jul 29 2005 Tom "spot" Callaway <tcallawa@redhat.com> 0.3.10-1
- Bump for new release

* Sat Jun 25 2005 Colin Charles <colin@fedoraproject.org> 0.3.9-2
- Fix download URL

* Fri Jun  3 2005 Tom "spot" Callaway <tcallawa@redhat.com> 0.3.9-1
- cleanup spec
- add emacs,xemacs BuildRequires
- bump to 0.3.9

* Tue May 10 2005 Tom "spot" Callaway <tcallawa@redhat.com> 0.3.8-7
- fix QuantLib-0.3.8-installdatahookfix.patch

* Sat Apr 16 2005 Tom "spot" Callaway <tcallawa@redhat.com> 0.3.8-6
- add tetex BuildRequires

* Fri Apr 15 2005 Tom "spot" Callaway <tcallawa@redhat.com> 0.3.8-5
- minor spec cleanups

* Thu Apr 14 2005 Tom "spot" Callaway <tcallawa@redhat.com> 0.3.8-4
- bump number because of cvs issues

* Mon Apr 11 2005 Tom "spot" Callaway <tcallawa@redhat.com> 0.3.8-3
- Cleanup docs handling

* Sat Apr  2 2005 Tom "spot" Callaway <tcallawa@redhat.com> 0.3.8-2
- add $(DESTDIR) to make install-data-hook
- rename two man pages due to generic name conflicts

* Fri Apr  1 2005 Tom "spot" Callaway <tcallawa@redhat.com> 0.3.8-1
- inital package for Fedora Extras
